package es.verdnatura.domain

import es.verdnatura.presentation.view.feature.ajustes.model.SectorItemVO
import es.verdnatura.presentation.view.feature.login.model.LoginSalixVO
import es.verdnatura.presentation.view.feature.login.model.SalixGrupo
import es.verdnatura.presentation.view.feature.login.model.SalixMessageVO
import es.verdnatura.presentation.view.feature.sacador.model.CollectionVO
import retrofit2.Call
import retrofit2.http.Body
import retrofit2.http.GET
import retrofit2.http.Header
import retrofit2.http.POST

interface SalixService {

    @POST("Accounts/login")
    fun login(@Header("Content-Type") content_type: String,
              @Body params: LoginSalixVO):
            Call<LoginSalixVO>

    @POST("chats/sendCheckingPresence")
    fun sendChekingPresence(
        @Header("Content-Type") content_type: String,
        @Header("Authorization") authorization: String,
        @Body params: SalixMessageVO):
            Call<Boolean>

    @POST("chats/send")
    fun sendGroup(
        @Header("Content-Type") content_type: String,
        @Header("Authorization") authorization: String,
        @Body params: SalixGrupo
    ):
            Call<Boolean>

    @GET("collections/getSectors")
    fun getSectorsSalix(
        @Header("Content-Type") content_type: String,
        @Header("Authorization") authorization: String,

    ):
            Call<List<SectorItemVO>>

    @GET("collections/getCollection")
    fun getCollectionSalix(
        @Header("Content-Type") content_type: String,
        @Header("Authorization") authorization: String,
    ):
            Call<List<CollectionVO>>


    @GET("collections/sectorCollection_get")
    fun sectorCollection_get(
        @Header("Content-Type") content_type: String,
        @Header("Authorization") authorization: String,
    ):
            Call<List<CollectionVO>>

}