package es.verdnatura.presentation.view.feature.ajustes.adapter

import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import es.verdnatura.databinding.ItemAjustesRowBinding
import es.verdnatura.presentation.common.OnAjustesItemClickListener
import es.verdnatura.presentation.view.feature.ajustes.model.AjustesItemVO

class AjustesAdapter (
    private val items: List<AjustesItemVO>,
    private val onAjustesItemClickListener: OnAjustesItemClickListener
): RecyclerView.Adapter<AjustesAdapter.AjustesItemHolder> () {


    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): AjustesItemHolder {
        return AjustesItemHolder(
            ItemAjustesRowBinding.inflate(LayoutInflater.from(parent.context),parent,false)
        )
    }

    override fun getItemCount() =items.size

    override fun onBindViewHolder(holder: AjustesItemHolder, position: Int) {
        holder.bind(items[position])
        holder.binding.root.setOnClickListener {
            onAjustesItemClickListener.onAjustesItemClickListener(items[position])
        }
    }


    class AjustesItemHolder(
        val binding: ItemAjustesRowBinding
    ) : RecyclerView.ViewHolder(binding.root){
        fun bind(item: AjustesItemVO) {
            binding.apply {
                this.item = item
            }
        }
    }
}