package es.verdnatura.presentation.view.feature.buffer.fragment

import android.os.Bundle
import android.view.View
import android.view.inputmethod.EditorInfo
import androidx.lifecycle.Observer
import es.verdnatura.R
import es.verdnatura.databinding.FragmentBufferBinding
import es.verdnatura.presentation.base.BaseFragment
import es.verdnatura.presentation.view.component.CustomDialog
import es.verdnatura.presentation.view.feature.main.activity.MainActivity

class BufferFragment(
    var entryPoint: String = ""
) : BaseFragment<FragmentBufferBinding, BufferFragmentViewModel>(BufferFragmentViewModel::class) {

    private var password = ""
    private var goBack: Boolean = false
    override fun getLayoutId(): Int = R.layout.fragment_buffer
    //private lateinit var customDialog: CustomDialog

    companion object {
        fun newInstance(entryPoint: String) = BufferFragment(entryPoint)
    }


    override fun init() {
        
        binding.splashProgress.visibility = View.GONE
        //customDialog = CustomDialog(requireContext())
        setToolbar()
        setEvents()
        super.init()
    }

    private fun setToolbar() {

        binding.mainToolbar.toolbarTitle.text = entryPoint
    }

    override fun onCreate(savedInstanceState: Bundle?) {

        password = getData(PASSWORD)
        super.onCreate(savedInstanceState)
    }

    private fun setEvents() {

        binding.mainToolbar.backButton.setOnClickListener {
            requireActivity().onBackPressed()
        }

        binding.scanInput.requestFocus()
         binding.scanInput.setOnEditorActionListener { _, actionId, _ ->
            if (actionId == EditorInfo.IME_ACTION_SEARCH || actionId == EditorInfo.IME_ACTION_DONE || actionId == 0) {
               // goBack = false
                if (! binding.scanInput.text.isNullOrEmpty()) {
                    binding.splashProgress.visibility = View.VISIBLE


                    when (entryPoint){
                        "Vaciado buffer"->entryPoint="UNLOADING"
                        "Llenado buffer"-> entryPoint="LOADING"
                        "Acumulación buffer"->entryPoint="ACCUMULATION"
                        "Desactivado buffer"->entryPoint="DISABLED"
                        "Flejado buffer"->entryPoint="STRAPPING"
                    }

                        viewModel.buffer_setTypeByName(
                            getData(USER),
                            getData(PASSWORD),
                            binding.scanInput.text.toString(),
                            entryPoint,
                            "buffer_setTypeByName"
                        )


                }
                 binding.scanInput.setText("")
                ma.hideKeyboard( binding.scanInput)
                return@setOnEditorActionListener true
            }
            false
        }
    }

    override fun observeViewModel() {

        with(viewModel) {
            itembuffertype.observe(viewLifecycleOwner, Observer {
                binding.splashProgress.visibility = View.GONE
                if (it.isError) {

                    ma.messageWithSound(
                            it.errorMessage,true,isPlayed = true)

                } else {

                    ma.messageWithSound("Operación "+entryPoint.lowercase() + " buffer realizada correctamente",false,isPlayed = true)
                    binding.mainToolbar.backButton.performClick()

                }

            })
        }

    }


}

