package es.verdnatura.presentation.view.feature.login.fragment

//import es.verdnatura.presentation.view.feature.login.model.LoginItemVO
import android.annotation.SuppressLint
import android.content.Context
import android.content.Intent
import android.content.SharedPreferences
import android.content.pm.PackageInfo
import android.content.pm.PackageManager
import android.net.Uri
import android.provider.Settings
import android.view.KeyEvent
import android.view.View
import androidx.preference.PreferenceManager
import es.verdnatura.R
import es.verdnatura.databinding.FragmentLoginBinding
import es.verdnatura.presentation.base.BaseFragment
import es.verdnatura.presentation.common.hideKeyboard
import es.verdnatura.presentation.view.component.CustomDialog
import es.verdnatura.presentation.view.feature.main.activity.MainActivity
import timber.log.Timber
import timber.log.Timber.d
import java.lang.Boolean.TRUE
import kotlin.system.exitProcess

class LoginFragment : BaseFragment<FragmentLoginBinding, LoginViewModel>(LoginViewModel::class) {

    private lateinit var customDialog: CustomDialog

    companion object {
        fun newInstance() = LoginFragment()
    }

    override fun getLayoutId(): Int = R.layout.fragment_login

    override fun init() {

        customDialog = CustomDialog(requireContext())
        saveIdentifiers()
        checkUser()
        binding.buttonLogin.setOnClickListener({
            binding.splashProgress.visibility = View.VISIBLE
        /*    viewModel.device_checkLogin(
                binding.edittextUsername.text.toString(),
                binding.edittextPassword.text.toString(),
                getData(ANDROID_ID), callFunction = "device_checkLogin"
            )
*/
            viewModel.loginSalix(
            user = binding.edittextUsername.text.toString(),
            password = binding.edittextPassword.text.toString(),
            callFunction = "login de Salix"
        )


        })

        binding.textviewRememberPassword.setOnClickListener {
            binding.edittextUsername.setText("")
            binding.edittextPassword.setText("")
            binding.switchRemember.isChecked = false
            saveRemember(false)
        }



        binding.edittextServer.setText(getData("base_url"))
        binding.edittextServer.setOnKeyListener { _, keyCode, event ->
            if (keyCode == KeyEvent.KEYCODE_ENTER && event.action == KeyEvent.ACTION_UP) {

                saveData(
                    "base_url",
                    binding.edittextServer.text.toString()
                )

                this.hideKeyboard()
                //sergio: deberia lanzar la funcion nueva creada por mi restartapp de BaseFragment. Pero no vuelve a arrancar
                exitProcess(0)

            }
            false
        }


        binding.textviewWelcome.setOnLongClickListener {
            binding.edittextServer.isEnabled = TRUE
            true
        }

        //NODEJS TEST
        /* Log.d("VERDNATURA:","NODEJS in")
           viewModel.nodeJsTest("A0A3B8224DBF","AAA","1")*/

    }

    @SuppressLint("HardwareIds")
    private fun saveIdentifiers() {

        val AndroidId: String = Settings.Secure.getString(requireActivity().contentResolver, Settings.Secure.ANDROID_ID)
        saveData(ANDROID_ID,AndroidId)

    }

    private fun checkUser() {
        val prefs: SharedPreferences = requireActivity().getSharedPreferences(PREFS_USER, 0)
        if (prefs.getBoolean(RECORDAR, false)) {
            binding.edittextUsername.setText(prefs.getString(USER, ""))
            binding.edittextPassword.setText(prefs.getString(PASSWORD, ""))
            if (binding.edittextPassword.text.toString().isNotEmpty()) {
                binding.switchRemember.isChecked = true
            }
        }

    }

    override fun observeViewModel() {
        with(viewModel) {

            versionappitem.observe(viewLifecycleOwner, {

                if (it.isError) {
                    binding.splashProgress.visibility = View.GONE
                    customDialog.setTitle("Error").setDescription(it.errorMessage)
                        .setOkButton("Cerrar") {
                            customDialog.dismiss()
                        }.show()
                } else {

                    if (it.version == getInfoVersionNameApp()) {
                        goToMain()
                    } else {

                        customDialog.setTitle(getString(R.string.Actualizar))
                            .setDescription(getString(R.string.updatemng)).setOkButton(
                                getString(
                                    R.string.Actualizar
                                )
                            ) {
                                val openURL = Intent(Intent.ACTION_VIEW)
                                openURL.data =
                                    Uri.parse("https://app.verdnatura.es/bin/vn-picking.apk")
                                startActivity(openURL)

                            }
                        if (it.IsVersionCritical == 1) {
                            customDialog.setDescription(getString(R.string.updatecritical))
                        } else {
                            customDialog.setKoButton("Cancelar") {
                                customDialog.dismiss()
                                goToMain()
                            }
                        }
                        customDialog.show()

                    }

                }

            })
            logindevice.observe(viewLifecycleOwner,  {

                if (it.isError) {
                    binding.splashProgress.visibility = View.GONE
                    customDialog.setTitle("Error").setDescription(it.errorMessage)
                        .setOkButton("Cerrar") {
                            customDialog.dismiss()
                        }.show()
                } else {
                    if (it.vIsAuthorized == "0") {

                        customDialog.setTitle("Error").setDescription(it.vMessage!!)
                            .setOkButton("Cerrar") {
                                customDialog.dismiss()
                                binding.splashProgress.visibility = View.GONE
                                //  goToMain()
                            }.show()

                    } else {
                        //sergio: se añade el log
                        viewModel.worker_getId(
                            binding.edittextUsername.text.toString(),
                            binding.edittextPassword.text.toString(),
                            callFunction = "worker_getId"
                        )

                        viewModel.worker_getSector(
                            binding.edittextUsername.text.toString(),
                            binding.edittextPassword.text.toString())

                        deviceLog_add(
                            binding.edittextUsername.text.toString(),
                            binding.edittextPassword.text.toString(),
                            "warehouse",
                            getInfoVersionNameApp(),
                            getData(ANDROID_ID), "deviceLog_add"
                        )

                            if (binding.switchRemember.isChecked) {
                                    saveRemember(true)
                                } else {
                                    saveRemember(false)
                                }

                        saveUserAccesPref(
                            binding.edittextUsername.text.toString(),
                            binding.edittextPassword.text.toString()
                        )


                        if (it.vIsAuthorized == "1" && it.vMessage.isNullOrEmpty()) {

                            getVersion()

                        }
                        if (it.vIsAuthorized == "1" && !it.vMessage.isNullOrEmpty()) {
                            binding.splashProgress.visibility = View.GONE
                            customDialog.setTitle("Mensaje").setDescription(it.vMessage)
                                .setOkButton("Cerrar") {
                                    customDialog.dismiss()
                                   /* binding.splashProgress.visibility = View.VISIBLE
                                    loginSalix(
                                        user = binding.edittextUsername.text.toString(),
                                        password = binding.edittextPassword.text.toString(),
                                        "login de Salix"
                                    )*/
                                    getVersion()
                                }.show()

                        }

                    }

                }

            })



            workerId.observe(viewLifecycleOwner,  {

                if (!it.isError) {
                    saveUserFkPref(it.Id.toString())
                }


            })


            devicelogresponse.observe(viewLifecycleOwner,  {

                if (it.isError) {
                    customDialog.setTitle("Error")
                        .setDescription(it.errorMessage)
                        .setOkButton(
                            "Aceptar"
                        ) {
                            customDialog.dismiss()
                            getVersion()
                        }.show()
                }
            })

            workergetSector.observe(viewLifecycleOwner,  {
                binding.splashProgress.visibility = View.GONE

                if (it.id!=0){
                    d("El sector guardado es"+it.id)
                    d("El sector description es"+it.description.toString())
                    d("El sector warehouse es"+it.warehouseFk.toString())
                    saveDataInt("sectorFk",it.id)
                    saveData("sectordescrip",it.description)
                    it.warehouseFk?.let { it1 -> saveDataInt("warehouseFk", it1) }
                }
            })


            loginsalixitem.observe(viewLifecycleOwner,  {

                if (it.isError) {
                    binding.splashProgress.visibility = View.GONE
                    saveTokenPref("")
                    customDialog.setTitle("Error")
                       // .setDescription(it.errorMessage + ". Puedes continuar pero algunas funcionalidades no estarán disponibles.")
                        .setDescription(it.errorMessage)
                        .setOkButton(
                            "Entendido"
                        ) {
                            customDialog.dismiss()
                            //getVersion()
                            //exitProcess(0)
                        }.show()
                } else {
                    saveTokenPref(it.token)
                    viewModel.device_checkLogin(
                        binding.edittextUsername.text.toString(),
                        binding.edittextPassword.text.toString(),
                        getData(ANDROID_ID), callFunction = "device_checkLogin"
                    )

                }
            })

        }
        super.observeViewModel()
    }

    private fun getInfoVersionNameApp(): String {
        val manager: PackageManager = requireContext().packageManager
        val info: PackageInfo = manager.getPackageInfo(requireContext().packageName, 0)
        return info.versionName
    }

    private fun saveTokenPref(token: String) {
        val prefs: SharedPreferences = requireActivity().getSharedPreferences(PREFS_USER, 0)
        val editor = prefs.edit()
        editor.putString(TOKEN, token)
        editor.apply()
    }

 /*   private fun saveUserFkPref(loginitem: LoginItemVO) {
        val prefs: SharedPreferences = requireActivity().getSharedPreferences(PREFS_USER, 0)
        val editor = prefs.edit()
        editor.putString(USERFK, loginitem.id)
        editor.apply()
    }*/

    private fun saveUserFkPref(workerId: String) {
        val prefs: SharedPreferences = requireActivity().getSharedPreferences(PREFS_USER, 0)
        val editor = prefs.edit()
        editor.putString(USERFK, workerId)
        editor.apply()
    }

    private fun saveUserAccesPref(user: String, password: String) {
        val prefs: SharedPreferences = requireActivity().getSharedPreferences(PREFS_USER, 0)
        val editor = prefs.edit()
        editor.putString(USER, user)
        editor.putString(PASSWORD, password)
        editor.apply()
    }

    private fun saveRemember(remember: Boolean) {
        val prefs: SharedPreferences = requireActivity().getSharedPreferences(PREFS_USER, 0)
        val editor = prefs.edit()
        editor.putBoolean(RECORDAR, remember)
        editor.apply()
    }

    private fun goToMain() {
        val intent = Intent(activity, MainActivity::class.java)
        startActivity(intent)
        //binding.splashProgress.visibility=View.GONE
        requireActivity().finish()
    }

    private fun getVersion() {
        binding.splashProgress.visibility = View.VISIBLE
        viewModel.checkVersion(
            user = binding.edittextUsername.text.toString(),
            password = binding.edittextPassword.text.toString(),
            nameApp = "warehouse", "getVersion"
        )

    }

    /*fun setDefaults(key: String?, value: String?, context: Context?) {

        val preferences: SharedPreferences = PreferenceManager.getDefaultSharedPreferences(context)
        val editor = preferences.edit()
        editor.putString(key, value)
        editor.commit()
    }*/

  /*  fun getDefaults(key: String?, context: Context?): String? {
        val preferences = PreferenceManager.getDefaultSharedPreferences(context)
        return preferences.getString(key, null)
    }*/

    // sergio:creada restart en BaseFragment para AjustesFragment...


}
