package es.verdnatura.presentation.view.feature.pasillero.fragment

import android.content.Context
import android.os.Bundle
import android.view.View
import androidx.recyclerview.widget.LinearLayoutManager
import es.verdnatura.R
import es.verdnatura.databinding.FragmentPasilleroBinding
import es.verdnatura.presentation.base.BaseFragment
import es.verdnatura.presentation.common.OnPasillerosItemClickListener
import es.verdnatura.presentation.view.feature.pasillero.adapter.PasillerosAdapter


class PasilleroFragment(
    var tagName: String = ""
) : BaseFragment<FragmentPasilleroBinding, PasilleroViewModel>(PasilleroViewModel::class) {

    private var pasillerosItemClickListener: OnPasillerosItemClickListener? = null

    companion object {
        fun newInstance(tagName: String) = PasilleroFragment(tagName)
    }

    override fun onAttach(context: Context) {
        super.onAttach(context)
        if (context is OnPasillerosItemClickListener) pasillerosItemClickListener = context
    }

    override fun getLayoutId(): Int = R.layout.fragment_pasillero

    override fun init() {
         ma.hideBottomNavigation(View.VISIBLE)
        binding.mainToolbar.toolbarTitle.text = tagName
        binding.mainToolbar.backButton.visibility = View.GONE
        super.init()
    }

    override fun onCreate(savedInstanceState: Bundle?) {

        if (tagName.equals("Verdnatura")) {
            viewModel.inititializeDefaultData()
        }

        if (tagName.equals("Paletizadores")) {
            viewModel.inititializeDefaultPallet()

        }

        if (tagName.equals("Gestión de buffer")) {
            viewModel.inititializeDefaultBuffer()

        }
        super.onCreate(savedInstanceState)
    }

    override fun observeViewModel() {
        with(viewModel) {

            binding.pasillerosItems.adapter= PasillerosAdapter(pasillerositem, pasillerosItemClickListener!!)
            binding.pasillerosItems.layoutManager =
                LinearLayoutManager(requireContext(), LinearLayoutManager.VERTICAL, false)
        }

        super.observeViewModel()

    }

}
