package es.verdnatura.presentation.view.feature.smarttag.register


import android.content.Context
import android.view.View
import android.view.View.*
import android.view.inputmethod.EditorInfo
import androidx.activity.OnBackPressedCallback
import androidx.lifecycle.Observer
import androidx.recyclerview.widget.LinearLayoutManager
import es.verdnatura.R
import es.verdnatura.databinding.FragmentSacadorAssociatesmarttagBinding
import es.verdnatura.domain.toast
import es.verdnatura.presentation.base.BaseFragment
import es.verdnatura.presentation.common.*
import es.verdnatura.presentation.view.component.CustomDialog
import es.verdnatura.presentation.view.component.CustomDialogList
import es.verdnatura.presentation.view.feature.main.activity.MainActivity
import es.verdnatura.presentation.view.feature.smarttag.adapter.SmartTagAdapter
import es.verdnatura.presentation.view.feature.smarttag.model.SmartTag
import es.verdnatura.presentation.view.feature.smarttag.sacador.fragment.SmartTagsViewModel

class RegisterSmartTagsFragment(
    var entryPoint: String = ""
) : BaseFragment<FragmentSacadorAssociatesmarttagBinding, SmartTagsViewModel>(
    SmartTagsViewModel::class
) {

    private var goBack: Boolean = false

    override fun getLayoutId(): Int = R.layout.fragment_sacador_associatesmarttag
    private lateinit var customDialog: CustomDialog
    private lateinit var customDialogList: CustomDialogList
    private var listSmartTags: ArrayList<SmartTag> = ArrayList()
    private var smartAdapter: SmartTagAdapter? = null
    private var itemScaned: String = ""


    companion object {
        fun newInstance(entryPoint: String) = RegisterSmartTagsFragment(entryPoint)
    }

    override fun onAttach(context: Context) {
        super.onAttach(context)
      //  sergio: en test: Log.i("VERDNATURA:","attached")
            val callback: OnBackPressedCallback =
                object : OnBackPressedCallback(true)
                {
                    override fun handleOnBackPressed() {
                        // Leave empty do disable back press or
                        // write your code which you want
                      //  Log.i("VERDNATURA:","PULSADO")

                    }
                }
            requireActivity().onBackPressedDispatcher.addCallback(
                this,
                callback
            )

        //if (context is OnCollectionSelectedListener) onCollectionSelectedListener = context
    }


    override fun init() {

        customDialog = CustomDialog(requireContext())
        customDialogList = CustomDialogList(requireContext())
        goBack = false
         ma.hideBottomNavigation(View.GONE)
        binding.splashProgress.visibility = GONE

        setEvents()
        setToolBar()

        showScanSmartTags()
        super.init()
    }

    override fun onPause() {
        goBack = true
        super.onPause()
    }

    private fun setToolBar() {

        binding.mainToolbar.toolbarTitle.text = entryPoint

    }


    private fun bindShelving_add(shelvingOrSmarttag: String) {

        binding.splashProgress.visibility = VISIBLE
        //poner el bindshelving aqui

        viewModel.workerShelving_add(getData(USER),
            getData(PASSWORD), shelvingOrSmarttag)
        if (listSmartTags.size < 1) {

        } else {
            ("http://localhost:7777/bindShelving/${listSmartTags.first().code}" + "&" + shelvingOrSmarttag + "&${listSmartTags.size}").toast(
                requireContext()
            )
        }
        itemScaned = shelvingOrSmarttag

    }

    private fun bindShelving_remove() {

        // binding.splashProgress.visibility = VISIBLE
        //ponser el unbindshleving aqui
        //sergio:esto se debe hacer en


        ("http://localhost:7777/unbindShelving/${listSmartTags.first().code}" + "&" + listSmartTags.last().code + "&${listSmartTags.size}").toast(
            requireContext()
        )
        listSmartTags.removeAt(listSmartTags.size - 1)
        smartAdapter!!.notifyDataSetChanged()


    }

    private fun scanRequest() {
        if (binding.scanInput != null) {
            binding.scanInput.requestFocus()
        }
        hideKeyboards()
    }

    private fun hideKeyboards() {
        try {
            requireActivity().hideKeyboard()
        } catch (e: Exception) {
        }
    }

    private fun setEvents() {

        binding.mainToolbar.backButton.setOnClickListener {
         //  Log.i("VERDNATURA:","PULSADO")
            requireActivity().onBackPressed()
        }

    }


    override fun observeViewModel() {


        with(viewModel) {
            binding.splashProgress.visibility = GONE
            responseadd.observe(viewLifecycleOwner, Observer {
              //  Log.i("VERDNATURA", "Revisar llamada de las etiquetas smarttags : ${it.response}")


                if (it.isError) {
                    ma.messageWithSound(it.errorMessage,true,false)
                   /* customDialog.setTitle("Error").setDescription(it.errorMessage)
                        .setOkButton("Cerrar") {
                            customDialog.dismiss()
                        }.show()*/
                } else {
                    var nameSmartTagwithWagon: String

                    //"Etiqueta/matrícula añadida correctamente".toast(context)
                    //var sizeSmartTags = listSmartTags.size + 1

                    nameSmartTagwithWagon =
                        getTextScaned(listSmartTags.size + 1) + itemScaned
                    customDialogList.setTitle(getTextToPosition(listSmartTags.size + 1))


                    listSmartTags.add(SmartTag(itemScaned, nameSmartTagwithWagon))
                    smartAdapter!!.notifyDataSetChanged()
                    customDialogList.setValue("")

                }
                binding.splashProgress.visibility = GONE
            })

        }

    }

    private fun getTextToPosition(TagsScaned: Int): String {
        var message = ""

        when (TagsScaned) {
            1 -> message = "Escanea etiqueta superior"
            2 -> message = "Escanea etiqueta del medio"
            3 -> message = "Escanea etiqueta inferior"
            4 -> message = "Carro escaneado"
        }

        return message

    }

    private fun getTextScaned(TagScaned: Int): String {
        var message = ""

        when (TagScaned) {
            1 -> message = "Carro:"
            2 -> message = "Etiqueta superior:"
            3 -> message = "Escanea del medio:"
            4 -> message = "Etiqueta inferior:"
        }

        return message

    }

    private fun showScanSmartTags() {

        customDialogList.setTitle("Escanea matrícula del carro y etiquetas smartTags de arriba a abajo.")
            .setOkButton("Finalizar") {

                ma.hideKeyboard(customDialogList.getEditText())

                if (listSmartTags.size > 0) {
                    //  setFragmentResult("requestkey", bundleOf("tagMode" to "SmartTag"))
                    customDialogList.dismiss()
                    // ma.openFragmentPickers()
                    /*listSmartTags.forEach {
                        Log.i("VERDNATURA:","El codigo es :${it.code}")
                        }
                      workerShelving_add(userFk, it.code!!)*/

                } else {
                    customDialog.setTitle("Atención").setDescription("No ha escaneado Smartags")
                        .setOkButton("Ok")
                        {
                            customDialog.dismiss()

                        }.show()
                }

            }.setKoButton("Deshacer") {
                ma.hideKeyboard(customDialogList.getEditText())

                if (!listSmartTags.isEmpty()) {

                    bindShelving_remove()

                } else {
                    customDialogList.dismiss()
                    requireActivity().onBackPressed()

                }


                //
            }.setValue("").show()

        customDialogList.getEditText().requestFocus()
        ma.hideKeyboard(customDialogList.getEditText())

        customDialogList.getEditText().setOnEditorActionListener { v, actionId, event ->
            if (actionId == EditorInfo.IME_ACTION_SEARCH || actionId == EditorInfo.IME_ACTION_DONE || actionId == 0 || actionId == 5 || actionId == 6) {
                if (!customDialogList.getValue().isNullOrEmpty()) {
                    // Log.i("VERDNATURA:", "scan valor ${customDialogList.getValue()}")

                    if (listSmartTags.size > 3) {

                        customDialog.setTitle("Atención")
                            .setDescription("Carro escaneado completamente.¿Registrar otro carro?")
                            .setOkButton("Ok")
                            {
                                listSmartTags.clear()
                                customDialog.dismiss()
                                showScanSmartTags()

                            }
                            .setKoButton("Salir") {
                                customDialog.dismiss()
                                customDialogList.dismiss()
                                requireActivity().onBackPressed()

                            }
                            .show()


                    } else {
                        bindShelving_add(customDialogList.getValue())
                    }

                    // showScanSmartTags(SmartTag(customDialogList.getValue()))
                    // listSmartTags.add(SmartTag(customDialogList.getValue()))
                    // smartAdapter!!.notifyDataSetChanged()

                }
                customDialogList.setValue("")
                ma.hideKeyboard(customDialogList.getEditText())
                return@setOnEditorActionListener true
            }
            false
        }


        smartAdapter = SmartTagAdapter(listSmartTags, object : OnSmartTagRowClickListener {
            override fun OnSmartTagRowClickListener(item: SmartTag) {
            }
        }, showDelete = false)
        customDialogList.getRecyclerView().adapter = smartAdapter
        customDialogList.getRecyclerView().layoutManager =
            LinearLayoutManager(requireContext(), LinearLayoutManager.VERTICAL, false)


    }


}



